local ANAME, A = select(1, ...);
local U = A.Utils;
local C = A.Constants;
local P = A.Player;
local R = A.Request;
local fb = A.Lib.FB;
local Cache = A.Cache;
local Bus = A.ChatBus;
local DungeonApi = A.Api.Dungeon;
local P = A.Player;
local LFG = A.Lfg;

local f = CreateFrame("Frame");
f:RegisterEvent("PLAYER_ENTERING_WORLD");
f:RegisterEvent("ADDON_LOADED")
f:SetScript("OnEvent", function(self, event, arg) 
    if event == "ADDON_LOADED" and arg == ANAME then
        --print("ADD LOADED", type(TabuLfgData));
    elseif event == "PLAYER_ENTERING_WORLD" then
        --print("PLAYER ENTER", type(TabuLfgData));
        Cache:Initialize();
        P:Initialize();
        Bus:Start();
        LFG:Start();
        A:Start();
    end

end);


function A:RegisterSlashCommands()


    _G["SLASH_"..ANAME.."1"] = "/tlfg";
    _G["SLASH_"..ANAME.."2"] = "/тлфг";
    SlashCmdList[ANAME] = function(cmd)
    
        -- Extract Parameters
        local param1, param2 = cmd:match("^([^%s]+)%s*(.*)$");
        param1 = (param1 and param1:lower() or cmd:lower());
        -- Options
        if (param1 == "") then
            A:ShowMainFrame();
            -- nothing 
        elseif (param1 == "companion") then
            if param2 == "on" then
                Cache:SetOption("companion.show", true);
            elseif param2 == "off" then
                Cache:SetOption("companion.show", false);
            else
                A:ToggleCompanion();
            end
        end

    end
    
end

function A:Start()

    self:RegisterSlashCommands();

    if Cache:GetOption("companion.show") then
        A:ShowCompanion();
    end

    TabuLfg = A;
    print("|cff00a0ffTabu-Lfg is On,|r |cffff8000type /tlfg|r");
end



