-- cache
local A = select(2, ...);
local Cache = A.Cache;


function Cache:Initialize()
    if not TabuLfgData then
        TabuLfgData = {};
        TabuLfgData.options = {};
    end
    if not TabuLfgGlobalData then
        TabuLfgGlobalData = {};
        TabuLfgGlobalData.options = {};
    end
    --print("-- cache initialized --");
end

local function GetOption(options, key, def)
    return options[key] or def;
end


function Cache:GetOption(key, def)
    local options = TabuLfgData.options;
    return GetOption(options, key, def);
end


function Cache:GetGlobalOption(key, def)
    --EnsureGlobalOptions();
    local options = TabuLfgGlobalData.options;
    return GetOption(options, key, def);
end


local function SetOption(options, key, val)
   options[key] = val;
end

function Cache:SetOption(key, val)
    --EnsureOptions();
    local options = TabuLfgData.options;
    return SetOption(options, key, val);
end

function Cache:SetGlobalOption(key, val)
    --EnsureGlobalOptions();
    local options = TabuLfgGlobalData.options;
    return SetOption(options, key, val);
end