local A = select(2, ...);
local Mixins = A.Mixins;

Mixins.Shorts = {};


function Mixins.Shorts:AddShorts(...)
    for _i = 1, select("#", ...) do
        local short = select(_i, ...);
        short = string.lower(short);
        table.insert(self.shorts, short);
        local store = self:_getShortsStore();
        store[short] = self;
    end
end


Mixins.ShortsApi = {};

function Mixins.ShortsApi:GetByShort(short, nextShort)
    if short == nil or short == "" then return end
    short = string.lower(short);    
    local store = self:_getShortsStore();    
    local res1 = store[short];
    if res1 then return res1 end;
    if nextShort then
        nextShort = string.lower(nextShort);
        return store[short .. " " .. nextShort];
    end
end

function Mixins.ShortsApi:FindByShort(someText)
    if someText == nil or someText == "" then return end
    someText = string.lower(someText);
    local store = self:_getShortsStore();

    for short, item in pairs(store) do
        short = string.gsub(short, '%s', ' ');
        local index = string.find(someText, short);
        if index then
            return item;
        end
    end

end

function Mixins.ShortsApi:FindId(someText)
    local item = self:FindByShort(someText);
    return item and item.id or nil;
end

function Mixins.ShortsApi:AddShorts(id, ...)
    local item;

    if type(id) == "string" then
        item = self:GetById(id)
    elseif type(id) == "table" then
        item = id;
    end

    item:AddShorts(...);

end