local A = select(2, ...);
local DB = A.PlayersDB;


--C_FriendList

DB.byId = {};
DB.byFullName = {};

function DB:Get(fullName)
    return self.byFullName[fullName];
end

function DB:Set(player)
    self.byFullName[player.fullName] = player;
end


function MyGetPlayerInfoByGUID(id)
    local OK, locClass, engClass, locRace, engRace, gender, name, server = pcall(GetPlayerInfoByGUID, id);
    if OK then
        return locClass, engClass, locRace, engRace, gender, name, server;
    -- else
    --     print("ERROR GUID: ", id)
    end
end


function DB:GetOrCreate(fullName, source, fields, rewrite) 
    
    

    local player = self:Get(fullName);
    local isNew = player == nil;

    if not player then
        player = {
            fullName = fullName,
            source = source,
        }
    end

    if type(fields) == "table" then
        Mixin(player, fields);
    end

    if player.id and not player.infoByGuid then
        --print("- guid", player.id);

        local locClass, engClass, locRace, engRace, gender, name, server = MyGetPlayerInfoByGUID(player.id);

        if not player.gender and gender then
            player.gender = gender;
        end

        if not player.race and race then
            player.race = engRace;
        end
    
        if not player.class and engClass then
            player.class = engClass;
        end
    
        if not player.server and server then
            player.server = server;
        end
    
        if not player.name and name then
            player.name = name;
        end

        player.infoByGuid = true;

    end

    if isNew then
        self.byFullName[player.fullName] = player;
    end

    return player;
end




local EventHandler = CreateFrame("Frame");
function EventHandler:ProcessWhoResposne()
    local returned, total = C_FriendList.GetNumWhoResults();
    for index = 1, returned do
        local info = C_FriendList.GetWhoInfo(index);
        -- TODO: update player info
        --Tabu.print(info);
    end
end

EventHandler:RegisterEvent("WHO_LIST_UPDATE");
EventHandler:SetScript("OnEvent", function(self)
    self:ProcessWhoResposne();
end);
